from clarabot_nano_common.common.error import log_escape_str
from clarabot_nano.common.request.server_general import AdminDriveDeleteBackupRoomRequest
from clarabot_nano.server.general.handler.admin.config_update.base import AbstractAdminConfigUpdateServerHandler


class DriveDeleteBackupRoomHandler(AbstractAdminConfigUpdateServerHandler):
    HANDLER_KEY = AdminDriveDeleteBackupRoomRequest.TYPE_KEY

    def _create_config_update_request(self) -> dict:
        return {
            "_handler_key": "drive:del-backup-room",
            "path": self.payload.get(AdminDriveDeleteBackupRoomRequest.PATH),
            "room_id": self.payload.get(AdminDriveDeleteBackupRoomRequest.TARGET_ROOM_ID),
        }

    def _log_message(self) -> str:
        return (
            f"Delete backup room {log_escape_str(self.payload.get(AdminDriveDeleteBackupRoomRequest.TARGET_ROOM_ID))} "
            f"to drive at {log_escape_str(self.payload.get(AdminDriveDeleteBackupRoomRequest.PATH))}"
        )
